/***************************************************************************
 *    WHSMK.C  - Smacker code for Witchaven II
 *
 *                                                     03/01/96 Les Bird
 ***************************************************************************/

#include "smack.h"
#include "svga.h"
#include "icorp.h"
//#include <memcheck.h>

#define   MAXRADBUFFS         64

#pragma pack(1);

// EG 17 Oct 2017: Externalize map names
#if 0
char *levelname[16] = {
     "antechamber of asmodeus",
     "halls of ragnoth",
     "lokis tomb",
     "forsaken realm",
     "eye of midian",
     "dungeon of disembowlment",
     "stronghold of chaos",
     "jaws of venom",
     "descent into doom",
     "hack n sniff",
     "straits of perdition",
     "plateau of insanity",
     "crypt of decay",
     "mausoleum of madness",
     "gateway into oblivion",
     "lungs of hell"
};
#endif
char levelname[64];

Smack *smk;

struct radbuftype
{
     long cache_ptr;
     long cache_length;
     char cache_lock;
};

struct radbuftype radbuf[MAXRADBUFFS];

extern
unsigned vixen;

extern
long frameplace;

extern
char palshifted;

extern
int  treasurescnt,
     treasuresfound,
     killcnt,
     kills,
     expgained,
     bonus;

extern
int  mapon;

extern
long qsetmode;

RCFUNC
void PTR4 *RADLINK
radmalloc(u32 numbytes)
{
     int  i;

     for (i = 0; i < MAXRADBUFFS; i++) {
          if (radbuf[i].cache_ptr == 0L) {
               break;
          }
     }
     if (i == MAXRADBUFFS) {
          crash("no more radbuff pointers");
     }
     radbuf[i].cache_lock = 200;
     radbuf[i].cache_length = numbytes;
     allocache(&(radbuf[i].cache_ptr), radbuf[i].cache_length,
               &(radbuf[i].cache_lock));
     if (radbuf[i].cache_ptr == 0L) {
          crash("radmalloc failed on");
     }
     return((void PTR4 *) radbuf[i].cache_ptr);
}

RCFUNC
void RADLINK
radfree(void PTR4 * ptr)
{
     int  i;

     for (i = 0; i < MAXRADBUFFS; i++)
     {
          if (radbuf[i].cache_ptr == (long) ptr)
          {
               radbuf[i].cache_lock = 1;
               break;
          }
     }
}

void
smkinit(unsigned int digifh)
{
     if (digifh != -1)
     {
          SmackSoundUseSOS3(digifh, 120);
     }
     else
     {
          SmackSoundUseSOS3(0, 120);
     }
     SmackTimerSetup();
}

#include  <ctype.h>
#pragma   off  (argsused)
void
texttobuf(char *buffer,short x,short y,short fontstart,char *text,short pal)
{
     short          letter,i,offset,sl;
     char           ltr,space;
     short          xl,yl,termxl,termyl;
     char           *buf=NULL;
     char           *pic=NULL;

     /* ASSUMES BUF of 320 x 200 DIMENSION */

     offset=0;
     sl=strlen(text);
     for( i=0; i<sl; i++ ) {
          space=0;
          ltr=toupper(text[i]);
          if( (x+offset) > 320 ) {
               break;
          }
          if( ltr == ' ' ) {
               offset+=6;
               continue;
          }
          if( (ltr >= 'A') && (ltr <= 'Z') ) {
               letter=ltr-'A';
          }
          else {
               if( (ltr >= '0') && (ltr <= '9') ) {
                    letter=ltr-'0'+26;                    
               }
               else {
                    letter=0;
               }
          }
          letter+=fontstart;
          if( waloff[letter] == 0 ) loadtile(letter);
          termxl=tilesizx[letter];     
          termyl=tilesizy[letter];
          yl=0;
          yloop:
               xl=0;
               buf=( char *)(buffer+(yl*320)+(y*320));
               pic=( char *)(waloff[letter]);
               xloop:          
                    if( *(pic+(xl*termyl)+yl) != 255 ) {
                         *(buf+x+offset+xl)=*(pic+(xl*termyl)+yl);
                    }
                    xl++;
                    if( xl < termxl ) goto xloop;
               yl++;
               if( yl < termyl ) goto yloop;
          offset+=termxl;
     }
}
#pragma on (argsused)

// EG 24 Sep 2015: Move intermission calculation and text display outside of the main smkplayseq
// EG 22 Aug 2017: Fixes made to score calculation
long intermission_calc(struct player *plr)
{
	long killp,rating,treap;
	
    if (kills > killcnt)
	{
		kills = killcnt;
    }
	if (killcnt == 0 || kills == killcnt)
		killp = 100;
	else
		killp = (kills * 100) / (killcnt+1);
    if (treasuresfound > treasurescnt)
	{
        treasuresfound = treasurescnt;
    }
	if(treasurescnt == 0 || treasuresfound == treasurescnt)
		treap = 100;
	else
		treap = (treasuresfound * 100) / (treasurescnt+1); 
    rating = (killp + treap) / 2;
	if (rating >= 95)
	{
        rating = 3;
    }
 	else if (rating >= 70)
    {
        rating = 2;
    }
	else if (rating >= 40)
	{
        rating = 1;
    }
	else
	{
		rating = 0;
	}
	
    bonus = rating * 500;
    plr->score += bonus;
	
	return rating;
}

void
smkplayseq(int s)
{
     int  frames=0;
     long dax,
          dax2,
          day,
          day2;
     long i;
	 long rating;
     char *ratings[]={
          "poor",
          "average",
          "good",
          "perfect"
     },*smklist[]={
          "intro.smk",
          "ending1.smk",
          "stairs.smk",
          "ending2.smk",
          "ending3.smk"
     };
     struct radbuftype   smkbuf;
     struct player *plr;

	 // EG: move plr set here
	 plr=&player[0];
	 
     // EG Bugfix: allow "full install" to HD
     sprintf(tempbuf,"%c:\\smk\\%s",vixen,smklist[s]);

     if (access(tempbuf,F_OK) != 0)
     {
          strcpy(tempbuf,smklist[s]);
     }
     if ((s == 0 || s == 1 || s == 3 || s == 4) && SoundMode)
     {
		  // EG 26 Sep. 2016: Add SMACKNOSKIP as per Adam Biser's advice
          smk=SmackOpen(tempbuf,SMACKTRACK1|SMACKNOSKIP,SMACKAUTOEXTRA);
     }
     else
     {
          smk=SmackOpen(tempbuf,0,SMACKAUTOEXTRA);
     }

	 // EG: Always calc rating and bonuses
	 if (s == 2)
	 {
	      rating = intermission_calc(plr);
	 }
	 
     if (smk)
     {
          smkbuf.cache_ptr=0L;
          smkbuf.cache_length=(320*200);
          smkbuf.cache_lock=200;
          allocache(&(smkbuf.cache_ptr),smkbuf.cache_length,
                    &(smkbuf.cache_lock));
          if( smkbuf.cache_ptr == 0L ) return;
        
          switch (s)
		  {
          case 0:
          case 1:
          case 3:
          case 4:
               SND_StopMusic();
               break;
          }
          keystatus[1] = 0;
          keystatus[28] = 0;
          keystatus[57] = 0;
          SVGADetect(0);
          if( !SVGASetup(320,200) )
          {
               goto done;
          }
          SmackToBuffer(smk,0L,0L,320L,200L,(void *)smkbuf.cache_ptr,0); 
          finishpaletteshifts();
          SVGASetGraph();
          while (1)
          {
               if (smk->NewPalette)
               {
                    SVGASetPalette(smk->Palette);
               }
               SmackDoFrame(smk);
               SmackNextFrame(smk);
               if (s == 2)
			   {
				        // EG 17 Oct 2017: Read map name from file
				        eg_read_mapname();
                        texttobuf(( void *)smkbuf.cache_ptr,10,13,THEFONT,levelname,0);
						texttobuf(( void *)smkbuf.cache_ptr,10, 31, THEFONT, "level conquered", 0);
						texttobuf(( void *)smkbuf.cache_ptr,10, 64, THEFONT, "enemies killed", 0);
						sprintf(tempbuf, "%d of %d", kills, killcnt);
						texttobuf(( void *)smkbuf.cache_ptr,160 + 48 + 14, 64, THEFONT, tempbuf, 0);
						texttobuf(( void *)smkbuf.cache_ptr,10, 64 + 18, THEFONT, "treasures found", 0);
						sprintf(tempbuf, "%d of %d",treasuresfound, treasurescnt);
						texttobuf(( void *)smkbuf.cache_ptr,160 + 48 + 14, 64 + 18, THEFONT, tempbuf, 0);

						texttobuf(( void *)smkbuf.cache_ptr,10, 64 + (18 * 2), THEFONT,
								"experience gained", 0);
						sprintf(tempbuf, "%d", expgained + bonus);
						texttobuf(( void *)smkbuf.cache_ptr,160 + 48 + 14, 64 + (18 * 2), THEFONT,
								tempbuf, 0);

						texttobuf(( void *)smkbuf.cache_ptr,10, 64 + (18 * 3), THEFONT,
								"rating", 0);
						texttobuf(( void *)smkbuf.cache_ptr,160 + 48 + 14, 64 + (18 * 3), THEFONT,
								ratings[rating], 0);

						texttobuf(( void *)smkbuf.cache_ptr,10, 64 + (18 * 4), THEFONT,
								"bonus", 0);
						sprintf(tempbuf, "%d", bonus);
						texttobuf(( void *)smkbuf.cache_ptr,160 + 48 + 14, 64 + (18 * 4), THEFONT,
								tempbuf, 0);	
               }
               SVGABlit(( void *)smkbuf.cache_ptr,0,0,320,200,320,0,0);
               while (SmackWait(smk))
               {
                   #ifdef ALLOWSCREENCAPTURE 
                    if( (svga == 0) && (keystatus[0x58] != 0) )
                    { 
                         keystatus[0x58] = 0;
                         screencapture("captxxxx.pcx", keystatus[0x2A]|keystatus[0x36]);
                    }
                   #endif
                    if (keystatus[1] || keystatus[57] || keystatus[28]) {
                         goto done;
                    }
               }
               if (keystatus[1] || keystatus[57] || keystatus[28]) {
                    goto done;
               }
               if (s == 1 || s == 3 || s == 4) {
                    frames++;
                    if (frames == smk->Frames) {
                         goto done;
                    }
               }
          }
     }
	 // EG 24 Sep 2015: Move "done" outside of the if to make sure cleanup stuff happens
	 done:
          smkbuf.cache_lock=1;
		  if (smk)
		  {
               SmackClose(smk);
		  }
          for (i = 0 ; i < MAXRADBUFFS ; i++)
          {
               radbuf[i].cache_lock = 1;
          }
          qsetmode=201;
          setgamemode();
          if( plr->dimension == 3 && svga == 0 ) {
               dax = (XDIM >> 1) - (plr->screensize >> 1);
               dax2 = dax + plr->screensize - 1;
               day = (STATUSSCREEN >> 1) - (((plr->screensize * STATUSSCREEN) / XDIM) >> 1);
               day2 = day + ((plr->screensize * STATUSSCREEN) / XDIM) - 1;
               setview(dax, day, dax2, day2);
               updatestatusbar();
          }
          if( plr->dimension == 3 && svga == 1 ) {
               if( plr->screensize == 320 ) {
                    setview(0L, 0L, 639L, 371L);
               }
               else {
                    setview(0L, 0L, 639L, 479L);
               }
               updatestatusbar();
          }
}


// EG 17 Oct 2017: Read map name from file
void eg_read_mapname(void)
{
	FILE *input_file;
	char mnbuffer[1024];
    char number[8];
	int i, j, cap, done, value;
	char filename[_MAX_FNAME+_MAX_EXT];
	
	done = i = j = 0;
	
	if (eg_gameflag)
    {
        strcpy(filename, eg_gamedir);
        strcat(filename, "\\mapnames.cfg");
    }
    else
    {
        strcpy(filename, "mapnames.cfg");
    }
	
	strcpy(levelname, "level ");
	itoa(mapon, mnbuffer, 10);
	strcat(levelname, mnbuffer);

    input_file = fopen(filename, "rb");
    if(input_file)
    {
		while(!done)
		{
			while(1)
			{
				if(!fgets(mnbuffer, 1024, input_file))
				{
					done = 1;
					break;
				}
				/* Eat leading whitespace */
				i = 0;
				while(mnbuffer[i] == ' ' || mnbuffer[i] == '\t')
				{
					++i;
				}

				/* Loop until we get a line that's relevant                              */
				/* Once it's not a comment or blank line, we can break out.              */
				if (mnbuffer[i] != '#' && mnbuffer[i] != '\n' && mnbuffer[i] != '\0')
					break;
				
			}

			cap = i + 7;
			j = 0;

			while(mnbuffer[i] != '\n' && mnbuffer[i] != '\0' && mnbuffer[i] != ' ' && mnbuffer[i] != '\t' && i < cap)
			{
				number[j] = mnbuffer[i];
				++i;
				++j;
			}

			number[j] = '\0';
			value = atoi(number);
			
			if(value == mapon)
			{
			/* Eat in-between whitespace */
			   while(mnbuffer[i] == ' ' || mnbuffer[i] == '\t')
			   {
                  ++i;
			   }
			
			   cap = i + 60;
			   j = 0;

			   while(mnbuffer[i] != '\t' && mnbuffer[i] != '\n' && mnbuffer[i] != '\0' && i < cap)
			   {
				   levelname[j] = mnbuffer[i];
				   ++i;
				   ++j;
			   }
			   levelname[j-1] = '\0';
			   done = 1;
			}
		}
		fclose(input_file); /* Make sure to close it */
	}
}